from CvPythonExtensions import *
import CvUtil
import CvScreensInterface
import CvDebugTools
import PyHelpers
import Popup as PyPopup
import CvCameraControls
import CvTopCivs
import sys
import os
import glob
import time
import CvAdvisorUtils
import CvTechChooser

## Ultrapack ##
import WBCityEditScreen
import WBUnitScreen
import WBPlayerScreen
import WBGameDataScreen
import WBPlotScreen
import CvPlatyBuilderScreen
## Ultrapack ##

gc = CyGlobalContext()
localText = CyTranslator()
PyPlayer = PyHelpers.PyPlayer
PyInfo = PyHelpers.PyInfo

# globals
###################################################
class CvEventManager:
    def __init__(self):
        #################### ON EVENT MAP ######################
        #print "EVENTMANAGER INIT"

        self.pb80 = {}
        self.bCtrl = False
        self.bShift = False
        self.bAlt = False
        self.bAllowCheats = False

        # OnEvent Enums
        self.EventLButtonDown=1
        self.EventLcButtonDblClick=2
        self.EventRButtonDown=3
        self.EventBack=4
        self.EventForward=5
        self.EventKeyDown=6
        self.EventKeyUp=7

        self.__LOG_MOVEMENT = 0
        self.__LOG_BUILDING = 0
        self.__LOG_COMBAT = 0
        self.__LOG_CONTACT = 0
        self.__LOG_IMPROVEMENT =0
        self.__LOG_CITYLOST = 0
        self.__LOG_CITYBUILDING = 0
        self.__LOG_TECH = 0
        self.__LOG_UNITBUILD = 0
        self.__LOG_UNITKILLED = 1
        self.__LOG_UNITLOST = 0
        self.__LOG_UNITPROMOTED = 0
        self.__LOG_UNITSELECTED = 0
        self.__LOG_UNITPILLAGE = 0
        self.__LOG_GOODYRECEIVED = 0
        self.__LOG_GREATPERSON = 0
        self.__LOG_RELIGION = 0
        self.__LOG_RELIGIONSPREAD = 0
        self.__LOG_GOLDENAGE = 0
        self.__LOG_ENDGOLDENAGE = 0
        self.__LOG_WARPEACE = 0
        self.__LOG_PUSH_MISSION = 0

        ## EVENTLIST
        self.EventHandlerMap = {
            'mouseEvent'            : self.onMouseEvent,
            'kbdEvent'                 : self.onKbdEvent,
            'ModNetMessage'                    : self.onModNetMessage,
            'Init'                    : self.onInit,
            'Update'                : self.onUpdate,
            'UnInit'                : self.onUnInit,
            'OnSave'                : self.onSaveGame,
            'OnPreSave'                : self.onPreSave,
            'OnLoad'                : self.onLoadGame,
            'GameStart'                : self.onGameStart,
            'GameEnd'                : self.onGameEnd,
            'plotRevealed'             : self.onPlotRevealed,
            'plotFeatureRemoved'     : self.onPlotFeatureRemoved,
            'plotPicked'            : self.onPlotPicked,
            'nukeExplosion'            : self.onNukeExplosion,
            'gotoPlotSet'            : self.onGotoPlotSet,
            'BeginGameTurn'            : self.onBeginGameTurn,
            'EndGameTurn'            : self.onEndGameTurn,
            'BeginPlayerTurn'        : self.onBeginPlayerTurn,
            'EndPlayerTurn'            : self.onEndPlayerTurn,
            'endTurnReady'            : self.onEndTurnReady,
            'combatResult'             : self.onCombatResult,
          'combatLogCalc'             : self.onCombatLogCalc,
          'combatLogHit'                : self.onCombatLogHit,
            'improvementBuilt'         : self.onImprovementBuilt,
            'improvementDestroyed'         : self.onImprovementDestroyed,
            'routeBuilt'         : self.onRouteBuilt,
            'firstContact'             : self.onFirstContact,
            'cityBuilt'             : self.onCityBuilt,
            'cityRazed'                : self.onCityRazed,
            'cityAcquired'             : self.onCityAcquired,
            'cityAcquiredAndKept'     : self.onCityAcquiredAndKept,
            'cityLost'                : self.onCityLost,
            'cultureExpansion'         : self.onCultureExpansion,
            'cityGrowth'             : self.onCityGrowth,
            'cityDoTurn'             : self.onCityDoTurn,
            'cityBuildingUnit'    : self.onCityBuildingUnit,
            'cityBuildingBuilding'    : self.onCityBuildingBuilding,
            'cityRename'                : self.onCityRename,
            'cityHurry'                : self.onCityHurry,
            'selectionGroupPushMission'        : self.onSelectionGroupPushMission,
            'unitMove'                 : self.onUnitMove,
            'unitSetXY'             : self.onUnitSetXY,
            'unitCreated'             : self.onUnitCreated,
            'unitBuilt'             : self.onUnitBuilt,
            'unitKilled'            : self.onUnitKilled,
            'unitLost'                : self.onUnitLost,
            'unitPromoted'            : self.onUnitPromoted,
            'unitSelected'            : self.onUnitSelected,
            'UnitRename'                : self.onUnitRename,
            'unitPillage'                : self.onUnitPillage,
            'unitSpreadReligionAttempt'    : self.onUnitSpreadReligionAttempt,
            'unitGifted'                : self.onUnitGifted,
            'unitBuildImprovement'                : self.onUnitBuildImprovement,
            'goodyReceived'            : self.onGoodyReceived,
            'greatPersonBorn'          : self.onGreatPersonBorn,
            'buildingBuilt'         : self.onBuildingBuilt,
            'projectBuilt'             : self.onProjectBuilt,
            'techAcquired'            : self.onTechAcquired,
            'techSelected'            : self.onTechSelected,
            'religionFounded'        : self.onReligionFounded,
            'religionSpread'        : self.onReligionSpread,
            'religionRemove'        : self.onReligionRemove,
            'corporationFounded'    : self.onCorporationFounded,
            'corporationSpread'        : self.onCorporationSpread,
            'corporationRemove'        : self.onCorporationRemove,
            'goldenAge'                : self.onGoldenAge,
            'endGoldenAge'            : self.onEndGoldenAge,
            'chat'                     : self.onChat,
            'victory'                : self.onVictory,
            'vassalState'            : self.onVassalState,
            'changeWar'                : self.onChangeWar,
            'setPlayerAlive'        : self.onSetPlayerAlive,
            'playerChangeStateReligion'        : self.onPlayerChangeStateReligion,
            'playerGoldTrade'        : self.onPlayerGoldTrade,
            'windowActivation'        : self.onWindowActivation,
            'gameUpdate'            : self.onGameUpdate,        # sample generic event
        }

        ################## Events List ###############################
        #
        # Dictionary of Events, indexed by EventID (also used at popup context id)
        #   entries have name, beginFunction, applyFunction [, randomization weight...]
        #
        # Normal events first, random events after
        #
        ################## Events List ###############################
        self.Events={
            CvUtil.EventEditCityName : ('EditCityName', self.__eventEditCityNameApply, self.__eventEditCityNameBegin),
            CvUtil.EventPlaceObject : ('PlaceObject', self.__eventPlaceObjectApply, self.__eventPlaceObjectBegin),
            CvUtil.EventAwardTechsAndGold: ('AwardTechsAndGold', self.__eventAwardTechsAndGoldApply, self.__eventAwardTechsAndGoldBegin),
            CvUtil.EventEditUnitName : ('EditUnitName', self.__eventEditUnitNameApply, self.__eventEditUnitNameBegin),
## Platy Builder ##
            CvUtil.EventWBLandmarkPopup : ('WBLandmarkPopup', self.__eventWBLandmarkPopupApply, self.__eventWBScriptPopupBegin),
            CvUtil.EventShowWonder: ('ShowWonder', self.__eventShowWonderApply, self.__eventShowWonderBegin),
            1111 : ('WBPlayerScript', self.__eventWBPlayerScriptPopupApply, self.__eventWBScriptPopupBegin),
            2222 : ('WBCityScript', self.__eventWBCityScriptPopupApply, self.__eventWBScriptPopupBegin),
            3333 : ('WBUnitScript', self.__eventWBUnitScriptPopupApply, self.__eventWBScriptPopupBegin),
            4444 : ('WBGameScript', self.__eventWBGameScriptPopupApply, self.__eventWBScriptPopupBegin),
            5555 : ('WBPlotScript', self.__eventWBPlotScriptPopupApply, self.__eventWBScriptPopupBegin),
## Platy Builder ##
        }
#################### EVENT STARTERS ######################
    def handleEvent(self, argsList):
        'EventMgr entry point'
        # extract the last 6 args in the list, the first arg has already been consumed
        self.origArgsList = argsList    # point to original
        tag = argsList[0]                # event type string
        idx = len(argsList)-6
        bDummy = false
        self.bDbg, bDummy, self.bAlt, self.bCtrl, self.bShift, self.bAllowCheats = argsList[idx:]
        ret = 0
        if self.EventHandlerMap.has_key(tag):
            fxn = self.EventHandlerMap[tag]
            ret = fxn(argsList[1:idx])
        return ret

#################### EVENT APPLY ######################
    def beginEvent( self, context, argsList=-1 ):
        'Begin Event'
        entry = self.Events[context]
        return entry[2]( argsList )

    def applyEvent( self, argsList ):
        'Apply the effects of an event '
        context, playerID, netUserData, popupReturn = argsList

        if context == CvUtil.PopupTypeEffectViewer:
            return CvDebugTools.g_CvDebugTools.applyEffectViewer( playerID, netUserData, popupReturn )

        entry = self.Events[context]

        if ( context not in CvUtil.SilentEvents ):
            self.reportEvent(entry, context, (playerID, netUserData, popupReturn) )
        return entry[1]( playerID, netUserData, popupReturn )   # the apply function

    def reportEvent(self, entry, context, argsList):
        'Report an Event to Events.log '
        if (gc.getGame().getActivePlayer() != -1):
            message = "DEBUG Event: %s (%s)" %(entry[0], gc.getActivePlayer().getName())
            CyInterface().addImmediateMessage(message,"")
            CvUtil.pyPrint(message)
        return 0

#################### ON EVENTS ######################
    def onKbdEvent(self, argsList):
        'keypress handler - return 1 if the event was consumed'

        eventType,key,mx,my,px,py = argsList
        game = gc.getGame()

        if (self.bAllowCheats):
            # notify debug tools of input to allow it to override the control
            argsList = (eventType,key,self.bCtrl,self.bShift,self.bAlt,mx,my,px,py,gc.getGame().isNetworkMultiPlayer())
            if ( CvDebugTools.g_CvDebugTools.notifyInput(argsList) ):
                return 0

        if ( eventType == self.EventKeyDown ):
            theKey=int(key)

            CvCameraControls.g_CameraControls.handleInput( theKey )
## AI AutoPlay ##
            if CyGame().getAIAutoPlay():
                if theKey == int(InputTypes.KB_SPACE) or theKey == int(InputTypes.KB_ESCAPE):
                    CyGame().setAIAutoPlay(0)
                    return 1
## AI AutoPlay ##
            if (self.bAllowCheats):
                # Shift - T (Debug - No MP)
                if (theKey == int(InputTypes.KB_T)):
                    if ( self.bShift ):
                        self.beginEvent(CvUtil.EventAwardTechsAndGold)
                        #self.beginEvent(CvUtil.EventCameraControlPopup)
                        return 1

                elif (theKey == int(InputTypes.KB_W)):
                    if ( self.bShift and self.bCtrl):
                        self.beginEvent(CvUtil.EventShowWonder)
                        return 1

                # Shift - ] (Debug - currently mouse-overd unit, health += 10
                elif (theKey == int(InputTypes.KB_LBRACKET) and self.bShift ):
                    unit = CyMap().plot(px, py).getUnit(0)
                    if ( not unit.isNone() ):
                        d = min( unit.maxHitPoints()-1, unit.getDamage() + 10 )
                        unit.setDamage( d, PlayerTypes.NO_PLAYER )

                # Shift - [ (Debug - currently mouse-overd unit, health -= 10
                elif (theKey == int(InputTypes.KB_RBRACKET) and self.bShift ):
                    unit = CyMap().plot(px, py).getUnit(0)
                    if ( not unit.isNone() ):
                        d = max( 0, unit.getDamage() - 10 )
                        unit.setDamage( d, PlayerTypes.NO_PLAYER )

                elif (theKey == int(InputTypes.KB_F1)):
                    if ( self.bShift ):
                        CvScreensInterface.replayScreen.showScreen(False)
                        return 1
                    # don't return 1 unless you want the input consumed

                elif (theKey == int(InputTypes.KB_F2)):
                    if ( self.bShift ):
                        import CvDebugInfoScreen
                        CvScreensInterface.showDebugInfoScreen()
                        return 1

                elif (theKey == int(InputTypes.KB_F3)):
                    if ( self.bShift ):
                        CvScreensInterface.showDanQuayleScreen(())
                        return 1

                elif (theKey == int(InputTypes.KB_F4)):
                    if ( self.bShift ):
                        CvScreensInterface.showUnVictoryScreen(())
                        return 1
        return 0

    def onModNetMessage(self, argsList):
        'Called whenever CyMessageControl().sendModNetMessage() is called - this is all for you modders!'

        iData1, iData2, iData3, iData4, iData5 = argsList
        print("Modder's net message!")

        CvUtil.pyPrint( 'onModNetMessage' )

    def onInit(self, argsList):
        'Called when Civ starts up'
        CvUtil.pyPrint( 'OnInit' )

    def onUpdate(self, argsList):
        'Called every frame'
        fDeltaTime = argsList[0]

        # allow camera to be updated
        CvCameraControls.g_CameraControls.onUpdate( fDeltaTime )

    def onWindowActivation(self, argsList):
        'Called when the game window activates or deactivates'
        bActive = argsList[0]

    def onUnInit(self, argsList):
        'Called when Civ shuts down'
        CvUtil.pyPrint('OnUnInit')

    def onPreSave(self, argsList):
        "called before a game is actually saved"
        CvUtil.pyPrint('OnPreSave')

    def onSaveGame(self, argsList):
        "return the string to be saved - Must be a string"
        return ""

    def onLoadGame(self, argsList):
        CvAdvisorUtils.resetNoLiberateCities()

        gamedata = {}
        gamedata["gameTurn"] = 0
        if gc.getGame().isNetworkMultiPlayer() and not CyGame().isPitbossHost():
            self.pb80_first_login(gamedata)
        #self.pb80_permanentWar()
        return 0

    def onGameStart(self, argsList):
        'Called at the start of the game'
        if (gc.getGame().getGameTurnYear() == gc.getDefineINT("START_YEAR") and not gc.getGame().isOption(GameOptionTypes.GAMEOPTION_ADVANCED_START)):
            for iPlayer in range(gc.getMAX_PLAYERS()):
                player = gc.getPlayer(iPlayer)
                if (player.isAlive() and player.isHuman()):
                    popupInfo = CyPopupInfo()
                    popupInfo.setButtonPopupType(ButtonPopupTypes.BUTTONPOPUP_PYTHON_SCREEN)
                    popupInfo.setText(u"showDawnOfMan")
                    popupInfo.addPopup(iPlayer)
        else:
            CyInterface().setSoundSelectionReady(true)

        if gc.getGame().isPbem():
            for iPlayer in range(gc.getMAX_PLAYERS()):
                player = gc.getPlayer(iPlayer)
                if (player.isAlive() and player.isHuman()):
                    popupInfo = CyPopupInfo()
                    popupInfo.setButtonPopupType(ButtonPopupTypes.BUTTONPOPUP_DETAILS)
                    popupInfo.setOption1(true)
                    popupInfo.addPopup(iPlayer)

        gamedata = {}
        gamedata["gameTurn"] = 0
        if not gc.getGame().isNetworkMultiPlayer():
            self.pb80 = {}
            self.pb80_handle(gamedata)
        """
        player_ids = range(0, 1)
        for i in player_ids:
            pPlayer = gc.getPlayer(i)
            iCiv = pPlayer.getCivilizationType()
            pTeam = gc.getTeam(pPlayer.getTeam())
            for iTech in range(gc.getNumTechInfos()):
                if (gc.getCivilizationInfo(iCiv).isCivilizationFreeTechs(iTech)):
                    pTeam.setHasTech(iTech+10, True, PlayerTypes.NO_PLAYER, False, False)
        """

        CvAdvisorUtils.resetNoLiberateCities()

    def onGameEnd(self, argsList):
        'Called at the End of the game'
        print("Game is ending")
        return

    def onBeginGameTurn(self, argsList):
        'Called at the beginning of the end of each turn'
        iGameTurn = argsList[0]
## AI AutoPlay ##
        if CyGame().getAIAutoPlay() == 0:
            CvTopCivs.CvTopCivs().turnChecker(iGameTurn)
## AI AutoPlay ##

        if not gc.getGame().isNetworkMultiPlayer():
            gamedata = {}
            gamedata["gameTurn"] = CyGame().getGameTurn()
            self.pb80_handle(gamedata)

############################################################################

    def pb80_handle(self, gamedata, bForce = False):
        """ Function to init pb80 data at Server startup and
        on each new round.  Moreover, it checks if  no player is connected to prevents OOS.
        """
        # Return if someone is online
        pingStatus = [p["ping"] for p in gamedata.get("players",[])]
        if "|[" in "|".join(pingStatus) and not bForce:
            return

        if self.pb80.get("turn") is None:
            self.pb80_init()
            self.pb80_new_round()
        elif self.pb80.get("turn") == gamedata.get("gameTurn") - 1:
            self.pb80_new_round()

        self.pb80_checkWindmills()
        self.pb80["turn"] = gamedata.get("gameTurn")

    def pb80_checkWindmills(self):
        # Gepluenderte Modernisierungen machen Ertragserhoehung rueckgaengig.
        WINDMILLS_NO_PEAKS = [ (41, 22), (61, 58), (66, 56), (67, 56), (73, 56), (109, 35)]
        WATERMILLS_NO_PEAKS = [ (48, 56), (88, 49), (88, 52), (101, 69), (110, 31)]
        iWatermill = gc.getInfoTypeForString("IMPROVEMENT_WATERMILL")
        iWindmill = gc.getInfoTypeForString("IMPROVEMENT_WINDMILL")
        for c in WINDMILLS_NO_PEAKS:
            plot = CyMap().plot(*c)
            if plot.getImprovementType() != iWindmill:
                if "X" not in plot.getScriptData():
                    plot.setScriptData("X")
                    # Change by -0N1P3G
                    CyGame().setPlotExtraYield(c[0], c[1], YieldTypes(1), -1)
                    CyGame().setPlotExtraYield(c[0], c[1], YieldTypes(2), -3)

        for c in WATERMILLS_NO_PEAKS:
            plot = CyMap().plot(*c)
            if plot.getImprovementType() != iWatermill:
                if "X" not in plot.getScriptData():
                    plot.setScriptData("X")
                    # Change by -1N1P2G
                    CyGame().setPlotExtraYield(c[0], c[1], YieldTypes(0), -1)
                    CyGame().setPlotExtraYield(c[0], c[1], YieldTypes(1), -1)
                    CyGame().setPlotExtraYield(c[0], c[1], YieldTypes(2), -2)

    def pb80_init(self):
        """ KSL Triere+Axt+Siedler wiederherstellen. """
        """
        pPlayer = gc.getPlayer(7)
        pPlayer.initUnit(gc.getInfoTypeForString("UNIT_GALLEY"), 54, 74, UnitAITypes.NO_UNITAI, DirectionTypes.NO_DIRECTION)
        pPlayer.initUnit(gc.getInfoTypeForString("UNIT_AXEMAN"), 54, 74, UnitAITypes.NO_UNITAI, DirectionTypes.NO_DIRECTION)
        pPlayer.initUnit(gc.getInfoTypeForString("UNIT_SETTLER"), 54, 74, UnitAITypes.NO_UNITAI, DirectionTypes.NO_DIRECTION)
        """
        """ Starke Piraten buffen ... """
        """
        lSchiffe = ["Brave Angelina"]
        pPlayer = gc.getPlayer(gc.getBARBARIAN_PLAYER())
        (loopUnit, iter) = pPlayer.firstUnit(False)
        while(loopUnit):
            if loopUnit.getNameNoDesc() in lSchiffe:
                loopUnit.setXY(38, 1, True, True, False)
                loopUnit.setImmobileTimer(20)
            if loopUnit.getUnitType() == gc.getInfoTypeForString("UNIT_PRIVATEER"):
                loopUnit.kill(True, -1)
                #loopUnit.setBaseCombatStr(3)

            (loopUnit, iter) = pPlayer.nextUnit(iter, False)
        """

        """ Jesper Kulturfix ... """
        """
        iBarb = 5 # Japan
        pBarb = gc.getPlayer(iBarb)
        (loopCity, iter) = pBarb.firstCity(False)
        while(loopCity):
            if loopCity.getCultureLevel() == 0:
                loopCity.setCulture(iBarb, 0, True)
                loopCity.setPopulation(4)
                isub = loopCity.getBuildingCommerceChange(gc.getInfoTypeForString("BUILDINGCLASS_GRANARY"), CommerceTypes.COMMERCE_CULTURE)
                if isub < 0:
                    isub = abs(isub)
                    loopCity.setBuildingCommerceChange(gc.getInfoTypeForString("BUILDINGCLASS_GRANARY"), CommerceTypes.COMMERCE_CULTURE, 2)

            (loopCity, iter) = pBarb.nextCity(iter, False)
        """
        """ Beam von Schiffen zur faireren Verteilung.... """
        """
        targetPlots = [(111,43),  # Bei Tirza
                       (70,46),  # Bei Caracol
                       (70-4,46+2)]  # Bei Caracol
                       # (61,48)]  # Bei Palembang
        les_palmistes = (91,34)
        aeolis = (43,32)
        lSchiffe = ["Benthic Explorer", "Vladislav Volkov", "Susannah"]
        lSchiffeUnbeladen = []  #, "Monmouth"]
        lSchiffeWeg = ["Monmouth", "Lord Dagon"]
        pPlayer = gc.getPlayer(gc.getBARBARIAN_PLAYER())
        iI = 0
        (loopUnit, iter) = pPlayer.firstUnit(False)
        while(loopUnit):
            if loopUnit.getNameNoDesc() in lSchiffe:
                loopUnit.setXY(targetPlots[iI%len(targetPlots)][0], targetPlots[iI%len(targetPlots)][1], True, True, False)
                iI += 1
            if loopUnit.getNameNoDesc() in lSchiffeUnbeladen:
                loopUnit.setXY(les_palmistes[0], les_palmistes[1], True, True, False)
            if loopUnit.getNameNoDesc() in lSchiffeWeg:
                if loopUnit.getX() == aeolis[0] and loopUnit.getY() == aeolis[1]:
                    loopUnit.kill(True, -1)

            (loopUnit, iter) = pPlayer.nextUnit(iter, False)
        """

        # gc.getPlayer(15).changeGold(-100)
        # gc.getPlayer(gc.getBARBARIAN_PLAYER()).changeGold(100)
        """ Patch fÃŒr Portugal. """
        """
        pKuh = CyMap().plot(89, 76)
        pEbene = CyMap().plot(90, 75)
        pPferd = CyMap().plot(89, 72)
        pKuh.setBonusType(gc.getInfoTypeForString("BONUS_COW"))
        pEbene.setTerrainType(gc.getInfoTypeForString("TERRAIN_PLAINS"), True, True)
        pPferd.setBonusType(gc.getInfoTypeForString("BONUS_HORSE"))
        pPferd.setTerrainType(gc.getInfoTypeForString("TERRAIN_GRASS"), True, True)
        """
        """ Patch fÃr Japan."""
        """
        pPferd1 = CyMap().plot(62, 25)
        pPferd1.setBonusType(gc.getInfoTypeForString("BONUS_HORSE"))
        """
        #pPferd2 = CyMap().plot(62, 21)
        #pPferd2.setBonusType(-1)
        """ # Rette Ziankali
        pPlot = CyMap().plot(98,18)
        n = pPlot.getNumUnits()
        while n > 0:
            pUnit = pPlot.getUnit(n)
            n -= 1
            if pUnit.getUnitType() != gc.getInfoTypeForString("UNIT_GALLEY"):
               pUnit.setName(pUnit.getName()+"X")
               pUnit.kill()
        """
        # Frankreich
        scriptData = CyMap().plot(0, 0).getScriptData()
        if "F" not in scriptData:
            pKuh = CyMap().plot(41, 40)
            pKuh.setBonusType(gc.getInfoTypeForString("BONUS_COW"))
            pPferd = CyMap().plot(46, 39)
            pPferd.setBonusType(gc.getInfoTypeForString("BONUS_HORSE"))
            (pCapitalFrance, iter) = gc.getPlayer(13).firstCity(False)
            if pCapitalFrance:
                # pCapitalFrance.changeFreeSpecialistCount(gc.getInfoTypeForString("SPECIALIST_GREAT_GENERAL"), 1)
                CvUtil.spawnUnit(gc.getInfoTypeForString("UNIT_GREAT_GENERAL"), pCapitalFrance.plot(), gc.getPlayer(13))
                # pCapitalFrance.changeFreeSpecialistCount(gc.getInfoTypeForString("SPECIALIST_SCIENTIST"), 1)

            # Remove Handelsposten from barbarian city
            pIkaria = CyMap().plot(39,2).getPlotCity()
            pIkaria.setNumRealBuilding(gc.getInfoTypeForString("BUILDING_VIKING_TRADING_POST"), 0)
            pIkaria.setNumRealBuilding(gc.getInfoTypeForString("BUILDING_CARTHAGE_COTHON"), 1)

            CyMap().plot(0, 0).setScriptData(scriptData+"F")

        if "G" not in scriptData:
            # Buchstabe verbraucht...
            CyMap().plot(0, 0).setScriptData(scriptData+"G")



        """ Patch fÃr China. """
        # gc.getPlayer(12).setGold(0)

        """ Patch fÃr Russland. """
        """
        pCorn = CyMap().plot(99, 14)
        pCorn.setBonusType(gc.getInfoTypeForString("BONUS_WHEAT"))
        """
        """ Coco Hinweis """
        """
        kCoords = [(22,56), (23,56), (23,54), (24,54), (23, 55), (22, 57)]
        pCoco = gc.getPlayer(1)
        for k in kCoords:
            CyMap().plot(*k).setRevealed(pCoco.getTeam(), True, False, -1)
        """
        # Segeln...
        # gc.getPlayer(15).changeGold(-400)
        # gc.getPlayer(gc.getBARBARIAN_PLAYER()).changeGold(400)
        # gc.getPlayer(15).changeGold(200)
        # gc.getPlayer(gc.getBARBARIAN_PLAYER()).changeGold(-200)

        """ add free great ing. to egpyt capital after founding. """
        scriptData = CyMap().plot(0, 0).getScriptData()
        if "B" not in scriptData:
            (pCapitalEgypt, iter) = gc.getPlayer(0).firstCity(False)
            if pCapitalEgypt:
                pCapitalEgypt.changeFreeSpecialistCount(gc.getInfoTypeForString("SPECIALIST_GREAT_ENGINEER"), 1)
                CyMap().plot(0, 0).setScriptData(scriptData+"B")

        """ Patch fuer Gr. Spione der Zuschauerciv"""
        # scheint so nicht zu klappen...
        """
        pPlayer = gc.getPlayer(15)
        (loopUnit, iter) = pPlayer.firstUnit(False)
        while(loopUnit):
            if loopUnit.getUnitType() == gc.getInfoTypeForString("UNIT_GREAT_SPY"):
                loopUnit.promote(gc.getInfoTypeForString("PROMOTION_MOBILITY") ,-1)

            (loopUnit, iter) = pPlayer.nextUnit(iter, False)
        """


        """ Backup fields with FEATURE_FALLOUT. Required at each reload. """
        iFallout = gc.getInfoTypeForString("FEATURE_FALLOUT")
        iGridW = CyMap().getGridWidth()
        iGridH = CyMap().getGridHeight()
        """
        falloutCoords = []
        for iX in range(iGridW):
            for iY in range(iGridH):
                plot = CyMap().plot(iX, iY)
                if plot.getFeatureType() == iFallout:
                    falloutCoords.append((iX, iY))
        """
        falloutCoords = [(15, 11), (30, 9), (34, 9), (35, 28), (45, 13), (51, 8), (52, 6), (52, 7), (52, 8), (52, 9), (53, 5), (53, 6), (53, 8), (54, 3), (54, 4), (54, 5), (54, 6), (54, 7), (54, 8), (55, 1), (55, 2), (55, 3), (55, 4), (55, 5), (55, 6), (56, 2), (56, 4), (57, 1), (80, 38), (90, 8), (90, 72), (112, 6), (113, 6), (117, 40)]

        self.pb80["falloutCoords"] = falloutCoords
        self.pb80_name_units()

        """ Finish turn for Zuschauer. """
        # Hm, civ taucht dann nicht mehr auf...
        """
        iZuschauer = 15
        CyGame().setActivePlayer(iZuschauer, False)
        CyMessageControl().sendTurnComplete()
        CyGame().setActivePlayer(-1, False)
        """

        """ Skip rest if already done. """
        if "A" in CyMap().plot(0, 0).getScriptData():
            return

        CyMap().plot(0, 0).setScriptData("done:A")

        """ Fix ocean plot yield. """
        water = [
            gc.getInfoTypeForString("TERRAIN_OCEAN"),
            gc.getInfoTypeForString("TERRAIN_COAST")]
        neighbours = [(-1,-1),(-1,0),(-1,1),(0,-1),(0,1),(1,-1),(1,0),(1,1)]
        for iX in range(iGridW):
            for iY in range(iGridH):
                plot = CyMap().plot(iX, iY)
                if plot.getTerrainType() not in water:
                    continue

                # if plot.getYield(YieldTypes(0)) < 1:
                if plot.calculateYield(YieldTypes(2), False) < 2:
                    # Skip field without yields.
                    continue

                if plot.getTerrainType() == water[1]:
                    # Check if nearby land
                    bCoast = False
                    for n in neighbours:
                        nX, nY = iX + n[0], iY + n[1]
                        if nX < 0 or nY < 0 or nX >= iGridW or nY >= iGridH:
                            continue
                        if CyMap().plot(nX, nY).getTerrainType() not in water:
                            bCoast = True
                            break

                    if not bCoast:
                        # Setze Ertrag auf Ozeanwert runter.
                        CyGame().setPlotExtraYield(iX, iY, YieldTypes(2), -1)

        """ Fix yield of some plots, if required. """
        iWatermill = gc.getInfoTypeForString("IMPROVEMENT_WATERMILL")
        iWindmill = gc.getInfoTypeForString("IMPROVEMENT_WINDMILL")
        for iX in range(iGridW):
            for iY in range(iGridH):
                plot = CyMap().plot(iX, iY)
                if plot.getImprovementType() == iWatermill:
                    # Change by 1N1P2G
                    CyGame().setPlotExtraYield(iX, iY, YieldTypes(0), 1)
                    CyGame().setPlotExtraYield(iX, iY, YieldTypes(1), 1)
                    CyGame().setPlotExtraYield(iX, iY, YieldTypes(2), 2)
                elif plot.getImprovementType() == iWindmill:
                    # Change by 0N1P3G
                    CyGame().setPlotExtraYield(iX, iY, YieldTypes(1), 1)
                    CyGame().setPlotExtraYield(iX, iY, YieldTypes(2), 3)

        self.pb80_mauern0()
        self.pb80_mauernA()
        self.pb80_mauernB()

        """ Spezialisten in London. (TODO)"""
        #pLondon = gc.getPlayer(4).getCity(0)
        #pLondon.changeExtraTradeRoutes(1)

        """ Join teams if both Barbarian civs not in the same."""
        iBarb = gc.getInfoTypeForString("LEADER_BARBARIAN")
        iBarbTeam = gc.getBARBARIAN_TEAM()
        for iP in xrange(52):
            gcPlayer = gc.getPlayer(iP)
            if gcPlayer.getTeam() == iBarbTeam:
                continue
            if gcPlayer.getLeaderType() == iBarb:
                gc.getTeam(iBarbTeam).addTeam(gcPlayer.getTeam())
                #gc.getTeam(gcPlayer.getTeam()).setVassal(iBarbTeam, True, True) # bringt nix

        # self.pb80_mauern()

        """ Great Wall in China reduce less spy points. """
        pPeking = gc.getPlayer(12).getCity(0)
        #pPeking.setNumRealBuilding(gc.getInfoTypeForString("BUILDING_GREAT_WALL"), 1)
        pPeking.changeGreatPeopleProgress(-50)
        pPeking.changeGreatPeopleUnitProgress(gc.getInfoTypeForString("UNIT_GREAT_SPY"), -1) # geht nicht.
        #pPeking.setFreeSpecialistCount (SpecialistType.SPCIALIST_SPY eIndex, INT iNewValue)

        #self.pb80_mauern0()
        #gc.getPlayer(15).setName(CyMap().plot(0, 0).getScriptData())

        #self.pb80_name_units()

    def pb80_mauern0(self):
        # Vorarbeit ohne Client
        scriptData = CyMap().plot(0, 0).getScriptData()
        CyMap().plot(0, 0).setScriptData(scriptData+str(gc.getBARBARIAN_PLAYER()))

        iBarb = 52 # gc.getBARBARIAN_PLAYER()
        iZuschauer = 15
        pBarb = gc.getPlayer(iBarb)
        pZuschauer = gc.getPlayer(iZuschauer)

        """ Noch eine Mauer :-) """
        pKushaner = CyMap().plot(89, 45).getPlotCity()
        kCoords = [(90, 51), (94, 48), (94, 47), (95, 47), (95, 46)]
        for k in kCoords:
            CyMap().plot(*k).setRevealed(pZuschauer.getTeam(), True, False, -1)
            CyMap().plot(*k).setOwner(iBarb)
            CyMap().plot(*k).setCulture(iBarb, 1, True)

        pKushaner.changeCulture(iBarb, 5000, True)

        """ Gr. Mauer von untergegangener Kultur. """
        cCoords = (70, 32)
        kCoords = [(69, 28), (68, 29), (69, 29), (67, 30), (68, 30), (69, 30), (70, 30), (71, 30), (72, 30), (73, 30), (67, 31), (68, 31), (69, 31), (70, 31), (71, 31), (72, 31), (73, 31), (66, 32), (67, 32), (68, 32), (69, 32), (70, 32), (71, 32), (72, 32), (73, 32), (74, 32), (67, 33), (68, 33), (69, 33), (70, 33), (71, 33), (72, 33), (73, 33), (74, 33), (66, 34), (67, 34), (71, 34), (72, 34), (73, 34), (66, 35), (71, 35), (72, 35), (66, 33)]

        pCity = pBarb.initCity(*cCoords)
        for k in kCoords:
            CyMap().plot(*k).setRevealed(pZuschauer.getTeam(), True, False, -1)
            CyMap().plot(*k).setOwner(iBarb)
            CyMap().plot(*k).setCulture(iBarb, 1, True)
        pCity.setNumRealBuilding(gc.getInfoTypeForString("BUILDING_CORPORATION_5"), 1)

    def pb80_mauernA(self):
        # Keine Mauergrafik, wenn PB-Server das Wunder initialisiert. Helfe nach...
        (pPeking, iter) = gc.getPlayer(12).firstCity(False)

        # Krankenhaus fuehrt nur zu Mauer-Grafik, wenn nicht schon Gr. Mauer
        # vorhanden. (Auskommentiert, da in PB_Platy GREAT_WALL nun keine Mauer
        # erzeugt...
        #pPeking.setNumRealBuilding(gc.getInfoTypeForString("BUILDING_GREAT_WALL"), 0)
        pPeking.setNumRealBuilding(gc.getInfoTypeForString("BUILDING_HOSPITAL"), 1)
        pPeking.setNumRealBuilding(gc.getInfoTypeForString("BUILDING_HOSPITAL"), 0)

        """ Noch eine Mauer :-) """
        pKushaner = CyMap().plot(89, 45).getPlotCity()
        pKushaner.setNumRealBuilding(gc.getInfoTypeForString("BUILDING_HOSPITAL"), 1)

        cCoords = (70, 32)
        pCity = CyMap().plot(*cCoords).getPlotCity()
        pCity.setNumRealBuilding(gc.getInfoTypeForString("BUILDING_HOSPITAL"), 1)

    def pb80_mauernB(self):
        # Revert operations... Can not be combined into one operation
        #     (in PB mode)

        (pPeking, iter) = gc.getPlayer(12).firstCity(False)
        pPeking.setNumRealBuilding(gc.getInfoTypeForString("BUILDING_HOSPITAL"), 0)
        #pPeking.setNumRealBuilding(gc.getInfoTypeForString("BUILDING_GREAT_WALL"), 1)

        iBarb = 52 # gc.getBARBARIAN_PLAYER()
        iZuschauer = 15
        pBarb = gc.getPlayer(iBarb)
        pZuschauer = gc.getPlayer(iZuschauer)

        """ Noch eine Mauer :-) """
        pKushaner = CyMap().plot(89, 45).getPlotCity()
        kCoords = [(90, 51), (94, 48), (94, 47), (95, 47), (95, 46)]
        pKushaner.setNumRealBuilding(gc.getInfoTypeForString("BUILDING_HOSPITAL"), 0)
        pKushaner.changeCulture(iBarb, -5000, True)
        for k in kCoords:
            CyMap().plot(*k).setCulture(iBarb, 0, True)
            CyMap().plot(*k).setOwner(-1)


        """ Gr. Mauer von untergegangener Kultur. """
        cCoords = (70, 32)
        kCoords = [(69, 28), (68, 29), (69, 29), (67, 30), (68, 30), (69, 30), (70, 30), (71, 30), (72, 30), (73, 30), (67, 31), (68, 31), (69, 31), (70, 31), (71, 31), (72, 31), (73, 31), (66, 32), (67, 32), (68, 32), (69, 32), (70, 32), (71, 32), (72, 32), (73, 32), (74, 32), (67, 33), (68, 33), (69, 33), (70, 33), (71, 33), (72, 33), (73, 33), (74, 33), (66, 34), (67, 34), (71, 34), (72, 34), (73, 34), (66, 35), (71, 35), (72, 35), (66, 33)]

        pCity = CyMap().plot(*cCoords).getPlotCity()
        pBarb.disband(pCity)
        CyMap().plot(*cCoords).setImprovementType(-1)
        for k in kCoords:
            CyMap().plot(*k).setOwner(-1)
            CyMap().plot(*k).setCulture(iBarb, 0, True)


        # Finally, reset view on whole Map.
        iGridW = CyMap().getGridWidth()
        iGridH = CyMap().getGridHeight()
        for iX in range(iGridW):
            for iY in range(iGridH):
                plot = CyMap().plot(iX, iY)
                if not plot.isVisible(pZuschauer.getTeam(), False):
                    plot.setRevealed(pZuschauer.getTeam(), False, False, -1)


    def pb80_new_round(self):
        """
        sprueche = [
        "Die Produktion von Schokopyramiden lässt die Wirtschaft florieren. Frohe Ostern!",
        "Die Produktion von Schokohasen lässt die Wirtschaft florieren. Frohe Ostern!",
        "Der Import von Schokohasen beglückt die portugiesischen Kinder. Die Älteren bewundern die Osterfeuer. Frohe Ostern!",
        "Der Fund eines Nests mit Fabregé-Eiern begeistert russische Wissenschafter! Frohe Ostern!",
        "Entenbraten sind in England verboten, aber die Menschen feiern trotzdem. Frohe Ostern!",
        "Tokugawas Tamagotchis (Kücken-Edition) beflügeln die japanische Wirtschaft. Frohe Ostern!",
        "Der Handel von Schokoeiern lässt die Wirtschaft florieren. Frohe Ostern!",
        "Mongolische Händler atmen auf: Kublai lässt Chef der Piraten köpfen. Der Schokoladen-Handel kann rechtzeitig wieder aufgenommen werden. Frohe Ostern!",
        "Der neue keltische Blutwein steht dem klingonsischen in nichts nach und wird weltberühmt. (Frohe Ostern!)",
        "Christus erleuchtet 2000 Christen im Lande. Oder war es ein Christ 2000 mal? Frohe Ostern.",
        "Zahlreiche Prozessionen bewegen die Menschen in Spanien. Frohe Ostern!",
        "Shakas Untertanen genießen Osterhase am Impi-Speer. Ein wahres Fest!",
        "China hat keinen Grund zum Feiern aber tut es trotzdem! Frohe Ostern.",
        "Osterfeuer ersetzen unchristliche Barbarenverbrennung in Frankreich. Das Volk jubelt. (Frohe Ostern)",
        "Es gibt keinen Has außer dem Osterhas. Sultan Erdohas ruft neuen Feiertag aus. (Frohe Ostern)",
        "Frohe Ostern LotC!",
        ]
        for iP in xrange(16):
                pPlayer = gc.getPlayer(iP)
                pPlayer.changeGoldenAgeTurns(1)
                CyInterface().addMessage(iP, True, 2, str(sprueche[iP%len(sprueche)]),
                                         None, 3, None, ColorTypes(4), 0, 0, False, False)
        """

        """ restore fallout fields. oos-source?!"""
        iFallout = gc.getInfoTypeForString("FEATURE_FALLOUT")
        for coords in self.pb80.get("falloutCoords", []):
            plot = CyMap().plot(*coords)
            if plot.getFeatureType() != iFallout:
                plot.setFeatureType(iFallout, 0)

        """ restore war with barbarian team. """
        iZuschauer = 15
        pBarbTeam = gc.getTeam(gc.getBARBARIAN_TEAM())
        for i in range(iZuschauer):
            pPlayer = gc.getPlayer(i)
            if not pBarbTeam.isAtWar(pPlayer.getTeam()):
                pBarbTeam.declareWar(pPlayer.getTeam(), False, -1)

        """ omit negative culture in barbarien cities. i want them to
        shrink, but if the city lost all their tiles it can not grown again...."""
        iBarb = gc.getBARBARIAN_PLAYER()
        pBarb = gc.getPlayer(iBarb)
        (loopCity, iter) = pBarb.firstCity(False)
        while(loopCity):
            if loopCity.getCultureLevel() == 0:
                # invertiere die negative kultur, die von der kornkammer
                # produziert wird.
                isub = loopCity.getBuildingCommerceChange(gc.getInfoTypeForString("BUILDINGCLASS_GRANARY"), CommerceTypes.COMMERCE_CULTURE)
                if isub < 0:
                    isub = abs(isub)
                    loopCity.setBuildingCommerceChange(gc.getInfoTypeForString("BUILDINGCLASS_GRANARY"), CommerceTypes.COMMERCE_CULTURE, 2)
                    #message = "pb80 debug event: invertiere kulturoutput von kornkammer in %s (%i)" %(loopCity.getName(), isub)
                    #CyInterface().addImmediateMessage(message,"")

            (loopCity, iter) = pBarb.nextCity(iter, False)

        # Kulturfix Spieler
        for iPl in xrange(15):
            pPl = gc.getPlayer(iPl)
            (loopCity, iter) = pPl.firstCity(False)
            while(loopCity):
                if loopCity.getCultureLevel() == 0:
                    loopCity.setCulture(iPl, 0, True)
                    isub = loopCity.getBuildingCommerceChange(gc.getInfoTypeForString("BUILDINGCLASS_GRANARY"), CommerceTypes.COMMERCE_CULTURE)
                    if isub < 0:
                        isub = abs(isub)
                        loopCity.setBuildingCommerceChange(gc.getInfoTypeForString("BUILDINGCLASS_GRANARY"), CommerceTypes.COMMERCE_CULTURE, 2)

                (loopCity, iter) = pPl.nextCity(iter, False)

        """ Add free Great Ing. to Egpyt capital after founding. """
        scriptData = CyMap().plot(0, 0).getScriptData()
        if "B" not in scriptData:
            (pCapitalEgypt, iter) = gc.getPlayer(0).firstCity(False)
            if pCapitalEgypt:
                pCapitalEgypt.changeFreeSpecialistCount(gc.getInfoTypeForString("SPECIALIST_GREAT_ENGINEER"), 1)
                CyMap().plot(0, 0).setScriptData(scriptData+"B")
                i = 0/0

        self.pb80_name_units()


    def pb80_name_units(self):
        """ Freibeuter-Schiffsnamen und reduzierte StÃ€rke und Bennennung von Landeinheiten. """

        if not globals().has_key("SCHIFFSNAMEN"):
            # Nachladen der Namen
            from UnitNames import SCHIFFSNAMEN, MAENNLICHE_NAMEN
            # pythonDir = os.path.join(gc.getAltrootDir(),'..','Python','v7')
            # execfile( os.path.join(pythonDir,'UnitNames.py'))

        lSchiffstypen = [gc.getInfoTypeForString("UNIT_PRIVATEER")
                         ,gc.getInfoTypeForString("UNIT_FRIGATE")
                         ,gc.getInfoTypeForString("UNIT_GALLEY")
                         ]
        lLandtypen = [gc.getInfoTypeForString("UNIT_WARRIOR")
                      ,gc.getInfoTypeForString("UNIT_AXEMAN")
                      ,gc.getInfoTypeForString("UNIT_SPEARMAN")
                      ,gc.getInfoTypeForString("UNIT_SWORDSMAN")
                      ,gc.getInfoTypeForString("UNIT_ARCHER")
                      ,gc.getInfoTypeForString("UNIT_LONGBOWMAN")
                      ,gc.getInfoTypeForString("UNIT_WORKER")
                      ,gc.getInfoTypeForString("UNIT_GRENADIER")
                      ,gc.getInfoTypeForString("UNIT_RIFLEMAN")
                      ,gc.getInfoTypeForString("UNIT_HORSE_ARCHER")
                      ,gc.getInfoTypeForString("UNIT_CHARIOT")
                      ,gc.getInfoTypeForString("UNIT_MACEMAN")
                      ,gc.getInfoTypeForString("UNIT_MUSKETMAN")
                      ,gc.getInfoTypeForString("UNIT_CROSSBOWMAN")
                      ,gc.getInfoTypeForString("UNIT_CHINA_CHOKONU")
                      ,gc.getInfoTypeForString("UNIT_ETHIOPIAN_OROMO_WARRIOR")
                      ]
        lTiertypen = [gc.getInfoTypeForString("UNIT_BEAR")]

        def get_name(lNames, iStart):
            iCur = iStart
            iStop = (iCur - 1) % len(lNames)
            while iStop != iCur:
                try:
                    # s = lNames[iCur].decode('ascii') # no umlautes, etc...
                    s = lNames[iCur].decode('utf-8')
                    # Check if all chars are printable
                    # https://en.wikipedia.org/wiki/Windows-1252
                    if max([ord(c) for c in s]) <= 255:
                        iCur = (iCur + 1) % len(lNames)
                        return [s, iCur]
                except UnicodeDecodeError:
                    pass
                except UnicodeEncodeError:
                    pass

                iCur = (iCur + 1) % len(lNames)

            return ["No name available", iCur]

        def name_units(iPlayer, lNames, lUnitTypes, match_handle, iStart):
            pPlayer = gc.getPlayer(iPlayer)
            (loopUnit, iter) = pPlayer.firstUnit(False)
            while(loopUnit):
                if loopUnit.getNameNoDesc() in ["Ridderschap van HollandOver the Rainbow"]:
                    loopUnit.setName("Ridderschap van Holland")
                    continue
                """ # Rettung von Ziankali vor erster Triere
                if loopUnit.getNameNoDesc() in ["Josua", "Eanfrith"]:
                    loopUnit.kill(True, loopUnit.getOwner())
                    continue
                """
                if loopUnit.getUnitType() in lUnitTypes:
                    if 0 == len(loopUnit.getNameNoDesc()):
                        if match_handle(loopUnit, True):
                            [uName, iStart] = get_name(lNames, iStart)
                            loopUnit.setName(uName)
                    # else:
                     #   match_handle(loopUnit, False)

                (loopUnit, iter) = pPlayer.nextUnit(iter, False)

        def ship_handle(loopUnit, bNewName):
            if bNewName:
                if loopUnit.getUnitType() == lSchiffstypen[0]:
                    # Freibeuter
                    loopUnit.setBaseCombatStr(4)
                if loopUnit.getUnitType() == lSchiffstypen[1]:
                    # Fregatte
                    pass

            return True

        def land_unit_handle(loopUnit, bNewName):
            return True

        def tier_unit_handle(loopUnit, bNewName):
            x = loopUnit.getX()
            y = loopUnit.getY()
            if x < 94 and x > 88 and y < 14 and y > 7:
                return True
            return False

        iBarb = gc.getBARBARIAN_PLAYER()
        # Schiffe
        iRandPos1 = (CyGame().getGameTurn() * 12348173929) % len(SCHIFFSNAMEN)
        name_units(iBarb, SCHIFFSNAMEN, lSchiffstypen, ship_handle, iRandPos1)

        # Landeinheiten
        iRandPos2 = (CyGame().getGameTurn() * 4812341497) % len(MAENNLICHE_NAMEN)
        name_units(iBarb, MAENNLICHE_NAMEN, lLandtypen, land_unit_handle, iRandPos2)

        # Ziankalis Nemesis
        name_units(iBarb, ["Fritz Gandalf"], lTiertypen, tier_unit_handle, 0)



############################################################################
    def onEndGameTurn(self, argsList):
        'Called at the end of the end of each turn'
        iGameTurn = argsList[0]

    def onBeginPlayerTurn(self, argsList):
        'Called at the beginning of a players turn'
        iGameTurn, iPlayer = argsList

    def onEndPlayerTurn(self, argsList):
        'Called at the end of a players turn'
        iGameTurn, iPlayer = argsList

        if (gc.getGame().getElapsedGameTurns() == 1):
            if (gc.getPlayer(iPlayer).isHuman()):
                if (gc.getPlayer(iPlayer).canRevolution(0)):
                    popupInfo = CyPopupInfo()
                    popupInfo.setButtonPopupType(ButtonPopupTypes.BUTTONPOPUP_CHANGECIVIC)
                    popupInfo.addPopup(iPlayer)

        CvAdvisorUtils.resetAdvisorNags()
        CvAdvisorUtils.endTurnFeats(iPlayer)

    def onEndTurnReady(self, argsList):
        iGameTurn = argsList[0]

    def onFirstContact(self, argsList):
    ## Platy Builder ##
        if CyGame().GetWorldBuilderMode() and not CvPlatyBuilderScreen.bPython: return
    ## Platy Builder ##
        'Contact'
        iTeamX,iHasMetTeamY = argsList
        if (not self.__LOG_CONTACT):
            return
        CvUtil.pyPrint('Team %d has met Team %d' %(iTeamX, iHasMetTeamY))

    def onCombatResult(self, argsList):
        'Combat Result'
        pWinner,pLoser = argsList
        playerX = PyPlayer(pWinner.getOwner())
        unitX = PyInfo.UnitInfo(pWinner.getUnitType())
        playerY = PyPlayer(pLoser.getOwner())
        unitY = PyInfo.UnitInfo(pLoser.getUnitType())
        if (not self.__LOG_COMBAT):
            return
        if playerX and playerX and unitX and playerY:
            CvUtil.pyPrint('Player %d Civilization %s Unit %s has defeated Player %d Civilization %s Unit %s'
                %(playerX.getID(), playerX.getCivilizationName(), unitX.getDescription(),
                playerY.getID(), playerY.getCivilizationName(), unitY.getDescription()))

    def onCombatLogCalc(self, argsList):
        'Combat Result'
        genericArgs = argsList[0][0]
        cdAttacker = genericArgs[0]
        cdDefender = genericArgs[1]
        iCombatOdds = genericArgs[2]
        CvUtil.combatMessageBuilder(cdAttacker, cdDefender, iCombatOdds)

    def onCombatLogHit(self, argsList):
        'Combat Message'
        global gCombatMessages, gCombatLog
        genericArgs = argsList[0][0]
        cdAttacker = genericArgs[0]
        cdDefender = genericArgs[1]
        iIsAttacker = genericArgs[2]
        iDamage = genericArgs[3]

        if cdDefender.eOwner == cdDefender.eVisualOwner:
            szDefenderName = gc.getPlayer(cdDefender.eOwner).getNameKey()
        else:
            szDefenderName = localText.getText("TXT_KEY_TRAIT_PLAYER_UNKNOWN", ())
        if cdAttacker.eOwner == cdAttacker.eVisualOwner:
            szAttackerName = gc.getPlayer(cdAttacker.eOwner).getNameKey()
        else:
            szAttackerName = localText.getText("TXT_KEY_TRAIT_PLAYER_UNKNOWN", ())

        if (iIsAttacker == 0):
            combatMessage = localText.getText("TXT_KEY_COMBAT_MESSAGE_HIT", (szDefenderName, cdDefender.sUnitName, iDamage, cdDefender.iCurrHitPoints, cdDefender.iMaxHitPoints))
            CyInterface().addCombatMessage(cdAttacker.eOwner,combatMessage)
            CyInterface().addCombatMessage(cdDefender.eOwner,combatMessage)
            if (cdDefender.iCurrHitPoints <= 0):
                combatMessage = localText.getText("TXT_KEY_COMBAT_MESSAGE_DEFEATED", (szAttackerName, cdAttacker.sUnitName, szDefenderName, cdDefender.sUnitName))
                CyInterface().addCombatMessage(cdAttacker.eOwner,combatMessage)
                CyInterface().addCombatMessage(cdDefender.eOwner,combatMessage)
        elif (iIsAttacker == 1):
            combatMessage = localText.getText("TXT_KEY_COMBAT_MESSAGE_HIT", (szAttackerName, cdAttacker.sUnitName, iDamage, cdAttacker.iCurrHitPoints, cdAttacker.iMaxHitPoints))
            CyInterface().addCombatMessage(cdAttacker.eOwner,combatMessage)
            CyInterface().addCombatMessage(cdDefender.eOwner,combatMessage)
            if (cdAttacker.iCurrHitPoints <= 0):
                combatMessage = localText.getText("TXT_KEY_COMBAT_MESSAGE_DEFEATED", (szDefenderName, cdDefender.sUnitName, szAttackerName, cdAttacker.sUnitName))
                CyInterface().addCombatMessage(cdAttacker.eOwner,combatMessage)
                CyInterface().addCombatMessage(cdDefender.eOwner,combatMessage)

    def onImprovementBuilt(self, argsList):
    ## Platy Builder ##
        if CyGame().GetWorldBuilderMode() and not CvPlatyBuilderScreen.bPython: return
    ## Platy Builder ##
        'Improvement Built'
        iImprovement, iX, iY = argsList
        if (not self.__LOG_IMPROVEMENT):
            return
        CvUtil.pyPrint('Improvement %s was built at %d, %d'
            %(PyInfo.ImprovementInfo(iImprovement).getDescription(), iX, iY))

    def onImprovementDestroyed(self, argsList):
    ## Platy Builder ##
        if CyGame().GetWorldBuilderMode() and not CvPlatyBuilderScreen.bPython: return
    ## Platy Builder ##
        'Improvement Destroyed'
        iImprovement, iOwner, iX, iY = argsList
        if (not self.__LOG_IMPROVEMENT):
            return
        CvUtil.pyPrint('Improvement %s was Destroyed at %d, %d'
            %(PyInfo.ImprovementInfo(iImprovement).getDescription(), iX, iY))

    def onRouteBuilt(self, argsList):
    ## Platy Builder ##
        if CyGame().GetWorldBuilderMode() and not CvPlatyBuilderScreen.bPython: return
    ## Platy Builder ##
        'Route Built'
        iRoute, iX, iY = argsList
        if (not self.__LOG_IMPROVEMENT):
            return
        CvUtil.pyPrint('Route %s was built at %d, %d'
            %(gc.getRouteInfo(iRoute).getDescription(), iX, iY))

    def onPlotRevealed(self, argsList):
    ## Platy Builder ##
        if CyGame().GetWorldBuilderMode() and not CvPlatyBuilderScreen.bPython: return
    ## Platy Builder ##
        'Plot Revealed'
        pPlot = argsList[0]
        iTeam = argsList[1]

    def onPlotFeatureRemoved(self, argsList):
        'Plot Revealed'
        pPlot = argsList[0]
        pCity = argsList[1]
        iFeatureType = argsList[2]

    def onPlotPicked(self, argsList):
        'Plot Picked'
        pPlot = argsList[0]
        CvUtil.pyPrint('Plot was picked at %d, %d'
            %(pPlot.getX(), pPlot.getY()))

    def onNukeExplosion(self, argsList):
        'Nuke Explosion'
        pPlot, pNukeUnit = argsList
        CvUtil.pyPrint('Nuke detonated at %d, %d'
            %(pPlot.getX(), pPlot.getY()))

    def onGotoPlotSet(self, argsList):
        'Nuke Explosion'
        pPlot, iPlayer = argsList

    def onBuildingBuilt(self, argsList):
        'Building Completed'
        pCity, iBuildingType = argsList
        game = gc.getGame()
        if ((not gc.getGame().isNetworkMultiPlayer()) and (pCity.getOwner() == gc.getGame().getActivePlayer()) and isWorldWonderClass(gc.getBuildingInfo(iBuildingType).getBuildingClassType())):
    ## Platy Builder ##
            if not CyGame().GetWorldBuilderMode():
    ## Platy Builder ##
                popupInfo = CyPopupInfo()
                popupInfo.setButtonPopupType(ButtonPopupTypes.BUTTONPOPUP_PYTHON_SCREEN)
                popupInfo.setData1(iBuildingType)
                popupInfo.setData2(pCity.getID())
                popupInfo.setData3(0)
                popupInfo.setText(u"showWonderMovie")
                popupInfo.addPopup(pCity.getOwner())

        CvAdvisorUtils.buildingBuiltFeats(pCity, iBuildingType)

        if (not self.__LOG_BUILDING):
            return
        CvUtil.pyPrint('%s was finished by Player %d Civilization %s'
            %(PyInfo.BuildingInfo(iBuildingType).getDescription(), pCity.getOwner(), gc.getPlayer(pCity.getOwner()).getCivilizationDescription(0)))

    def onProjectBuilt(self, argsList):
        'Project Completed'
        pCity, iProjectType = argsList
        game = gc.getGame()
        if ((not gc.getGame().isNetworkMultiPlayer()) and (pCity.getOwner() == gc.getGame().getActivePlayer())):
    ## Platy Builder ##
            if not CyGame().GetWorldBuilderMode():
    ## Platy Builder ##
                popupInfo = CyPopupInfo()
                popupInfo.setButtonPopupType(ButtonPopupTypes.BUTTONPOPUP_PYTHON_SCREEN)
                popupInfo.setData1(iProjectType)
                popupInfo.setData2(pCity.getID())
                popupInfo.setData3(2)
                popupInfo.setText(u"showWonderMovie")
                popupInfo.addPopup(pCity.getOwner())

    def onSelectionGroupPushMission(self, argsList):
        'selection group mission'
        eOwner = argsList[0]
        eMission = argsList[1]
        iNumUnits = argsList[2]
        listUnitIds = argsList[3]
        if (not self.__LOG_PUSH_MISSION):
            return
        if pHeadUnit:
            CvUtil.pyPrint("Selection Group pushed mission %d" %(eMission))

    def onUnitMove(self, argsList):
        'unit move'
        pPlot,pUnit,pOldPlot = argsList
        player = PyPlayer(pUnit.getOwner())
        unitInfo = PyInfo.UnitInfo(pUnit.getUnitType())
        if (not self.__LOG_MOVEMENT):
            return
        if player and unitInfo:
            CvUtil.pyPrint('Player %d Civilization %s unit %s is moving to %d, %d'
                %(player.getID(), player.getCivilizationName(), unitInfo.getDescription(),
                pUnit.getX(), pUnit.getY()))

    def onUnitSetXY(self, argsList):
        'units xy coords set manually'
        pPlot,pUnit = argsList
        player = PyPlayer(pUnit.getOwner())
        unitInfo = PyInfo.UnitInfo(pUnit.getUnitType())
        if (not self.__LOG_MOVEMENT):
            return

    def onUnitCreated(self, argsList):
    ## Platy Builder ##
        if CyGame().GetWorldBuilderMode() and not CvPlatyBuilderScreen.bPython: return
    ## Platy Builder ##
        'Unit Completed'
        unit = argsList[0]
        player = PyPlayer(unit.getOwner())
        if (not self.__LOG_UNITBUILD):
            return

    def onUnitBuilt(self, argsList):
        'Unit Completed'
        city = argsList[0]
        unit = argsList[1]
        player = PyPlayer(city.getOwner())
        CvAdvisorUtils.unitBuiltFeats(city, unit)
        if (not self.__LOG_UNITBUILD):
            return
        CvUtil.pyPrint('%s was finished by Player %d Civilization %s'
            %(PyInfo.UnitInfo(unit.getUnitType()).getDescription(), player.getID(), player.getCivilizationName()))

    def onUnitKilled(self, argsList):
        'Unit Killed'
        unit, iAttacker = argsList
        player = PyPlayer(unit.getOwner())
        attacker = PyPlayer(iAttacker)
        if (not self.__LOG_UNITKILLED):
            return
        CvUtil.pyPrint('Player %d Civilization %s Unit %s was killed by Player %d'
            %(player.getID(), player.getCivilizationName(), PyInfo.UnitInfo(unit.getUnitType()).getDescription(), attacker.getID()))

    def onUnitLost(self, argsList):
    ## Platy Builder ##
        if CyGame().GetWorldBuilderMode() and not CvPlatyBuilderScreen.bPython: return
    ## Platy Builder ##
        'Unit Lost'
        unit = argsList[0]
        player = PyPlayer(unit.getOwner())
        if (not self.__LOG_UNITLOST):
            return
        CvUtil.pyPrint('%s was lost by Player %d Civilization %s'
            %(PyInfo.UnitInfo(unit.getUnitType()).getDescription(), player.getID(), player.getCivilizationName()))

    def onUnitPromoted(self, argsList):
        'Unit Promoted'
        pUnit, iPromotion = argsList
        player = PyPlayer(pUnit.getOwner())
        if (not self.__LOG_UNITPROMOTED):
            return
        CvUtil.pyPrint('Unit Promotion Event: %s - %s' %(player.getCivilizationName(), pUnit.getName(),))

    def onUnitSelected(self, argsList):
        'Unit Selected'
        unit = argsList[0]
        player = PyPlayer(unit.getOwner())
        if (not self.__LOG_UNITSELECTED):
            return
        CvUtil.pyPrint('%s was selected by Player %d Civilization %s'
            %(PyInfo.UnitInfo(unit.getUnitType()).getDescription(), player.getID(), player.getCivilizationName()))

    def onUnitRename(self, argsList):
        'Unit is renamed'
        pUnit = argsList[0]
        if (pUnit.getOwner() == gc.getGame().getActivePlayer()):
            self.__eventEditUnitNameBegin(pUnit)

    def onUnitPillage(self, argsList):
        'Unit pillages a plot'
        pUnit, iImprovement, iRoute, iOwner = argsList
        iPlotX = pUnit.getX()
        iPlotY = pUnit.getY()
        pPlot = CyMap().plot(iPlotX, iPlotY)

        if (not self.__LOG_UNITPILLAGE):
            return
        CvUtil.pyPrint("Player %d's %s pillaged improvement %d and route %d at plot at (%d, %d)"
            %(iOwner, PyInfo.UnitInfo(pUnit.getUnitType()).getDescription(), iImprovement, iRoute, iPlotX, iPlotY))

    def onUnitSpreadReligionAttempt(self, argsList):
        'Unit tries to spread religion to a city'
        pUnit, iReligion, bSuccess = argsList

        iX = pUnit.getX()
        iY = pUnit.getY()
        pPlot = CyMap().plot(iX, iY)
        pCity = pPlot.getPlotCity()

    def onUnitGifted(self, argsList):
        'Unit is gifted from one player to another'
        pUnit, iGiftingPlayer, pPlotLocation = argsList

    def onUnitBuildImprovement(self, argsList):
        'Unit begins enacting a Build (building an Improvement or Route)'
        pUnit, iBuild, bFinished = argsList

    def onGoodyReceived(self, argsList):
        'Goody received'
        iPlayer, pPlot, pUnit, iGoodyType = argsList
        if (not self.__LOG_GOODYRECEIVED):
            return
        CvUtil.pyPrint('%s received a goody' %(gc.getPlayer(iPlayer).getCivilizationDescription(0)),)

    def onGreatPersonBorn(self, argsList):
    ## Platy Builder ##
        if CyGame().GetWorldBuilderMode() and not CvPlatyBuilderScreen.bPython: return
    ## Platy Builder ##
        'Unit Promoted'
        pUnit, iPlayer, pCity = argsList
        player = PyPlayer(iPlayer)
        if pUnit.isNone() or pCity.isNone():
            return
        if (not self.__LOG_GREATPERSON):
            return
        CvUtil.pyPrint('A %s was born for %s in %s' %(pUnit.getName(), player.getCivilizationName(), pCity.getName()))

    def onTechAcquired(self, argsList):
    ## Platy Builder ##
        if CyGame().GetWorldBuilderMode() and not CvPlatyBuilderScreen.bPython: return
    ## Platy Builder ##
        'Tech Acquired'
        iTechType, iTeam, iPlayer, bAnnounce = argsList
        # Note that iPlayer may be NULL (-1) and not a refer to a player object

        # Show tech splash when applicable
        if (iPlayer > -1 and bAnnounce and not CyInterface().noTechSplash()):
            if (gc.getGame().isFinalInitialized() and not gc.getGame().GetWorldBuilderMode()):
                if ((not gc.getGame().isNetworkMultiPlayer()) and (iPlayer == gc.getGame().getActivePlayer())):
                    popupInfo = CyPopupInfo()
                    popupInfo.setButtonPopupType(ButtonPopupTypes.BUTTONPOPUP_PYTHON_SCREEN)
                    popupInfo.setData1(iTechType)
                    popupInfo.setText(u"showTechSplash")
                    popupInfo.addPopup(iPlayer)

        if (not self.__LOG_TECH):
            return
        CvUtil.pyPrint('%s was finished by Team %d'
            %(PyInfo.TechnologyInfo(iTechType).getDescription(), iTeam))

    def onTechSelected(self, argsList):
        'Tech Selected'
        iTechType, iPlayer = argsList
        if (not self.__LOG_TECH):
            return
        CvUtil.pyPrint('%s was selected by Player %d' %(PyInfo.TechnologyInfo(iTechType).getDescription(), iPlayer))

    def onReligionFounded(self, argsList):
    ## Platy Builder ##
        if CyGame().GetWorldBuilderMode() and not CvPlatyBuilderScreen.bPython: return
    ## Platy Builder ##
        'Religion Founded'
        iReligion, iFounder = argsList
        player = PyPlayer(iFounder)

        iCityId = gc.getGame().getHolyCity(iReligion).getID()
        if (gc.getGame().isFinalInitialized() and not gc.getGame().GetWorldBuilderMode()):
            if ((not gc.getGame().isNetworkMultiPlayer()) and (iFounder == gc.getGame().getActivePlayer())):
                popupInfo = CyPopupInfo()
                popupInfo.setButtonPopupType(ButtonPopupTypes.BUTTONPOPUP_PYTHON_SCREEN)
                popupInfo.setData1(iReligion)
                popupInfo.setData2(iCityId)
                popupInfo.setData3(1)
                popupInfo.setText(u"showWonderMovie")
                popupInfo.addPopup(iFounder)

        if (not self.__LOG_RELIGION):
            return
        CvUtil.pyPrint('Player %d Civilization %s has founded %s'
            %(iFounder, player.getCivilizationName(), gc.getReligionInfo(iReligion).getDescription()))

    def onReligionSpread(self, argsList):
    ## Platy Builder ##
        if CyGame().GetWorldBuilderMode() and not CvPlatyBuilderScreen.bPython: return
    ## Platy Builder ##
        'Religion Has Spread to a City'
        iReligion, iOwner, pSpreadCity = argsList
        player = PyPlayer(iOwner)
        if (not self.__LOG_RELIGIONSPREAD):
            return
        CvUtil.pyPrint('%s has spread to Player %d Civilization %s city of %s'
            %(gc.getReligionInfo(iReligion).getDescription(), iOwner, player.getCivilizationName(), pSpreadCity.getName()))

    def onReligionRemove(self, argsList):
    ## Platy Builder ##
        if CyGame().GetWorldBuilderMode() and not CvPlatyBuilderScreen.bPython: return
    ## Platy Builder ##
        'Religion Has been removed from a City'
        iReligion, iOwner, pRemoveCity = argsList
        player = PyPlayer(iOwner)
        if (not self.__LOG_RELIGIONSPREAD):
            return
        CvUtil.pyPrint('%s has been removed from Player %d Civilization %s city of %s'
            %(gc.getReligionInfo(iReligion).getDescription(), iOwner, player.getCivilizationName(), pRemoveCity.getName()))

    def onCorporationFounded(self, argsList):
    ## Platy Builder ##
        if CyGame().GetWorldBuilderMode() and not CvPlatyBuilderScreen.bPython: return
    ## Platy Builder ##
        'Corporation Founded'
        iCorporation, iFounder = argsList
        player = PyPlayer(iFounder)

        if (not self.__LOG_RELIGION):
            return
        CvUtil.pyPrint('Player %d Civilization %s has founded %s'
            %(iFounder, player.getCivilizationName(), gc.getCorporationInfo(iCorporation).getDescription()))

    def onCorporationSpread(self, argsList):
    ## Platy Builder ##
        if CyGame().GetWorldBuilderMode() and not CvPlatyBuilderScreen.bPython: return
    ## Platy Builder ##
        'Corporation Has Spread to a City'
        iCorporation, iOwner, pSpreadCity = argsList
        player = PyPlayer(iOwner)
        if (not self.__LOG_RELIGIONSPREAD):
            return
        CvUtil.pyPrint('%s has spread to Player %d Civilization %s city of %s'
            %(gc.getCorporationInfo(iCorporation).getDescription(), iOwner, player.getCivilizationName(), pSpreadCity.getName()))

    def onCorporationRemove(self, argsList):
    ## Platy Builder ##
        if CyGame().GetWorldBuilderMode() and not CvPlatyBuilderScreen.bPython: return
    ## Platy Builder ##
        'Corporation Has been removed from a City'
        iCorporation, iOwner, pRemoveCity = argsList
        player = PyPlayer(iOwner)
        if (not self.__LOG_RELIGIONSPREAD):
            return
        CvUtil.pyPrint('%s has been removed from Player %d Civilization %s city of %s'
            %(gc.getReligionInfo(iReligion).getDescription(), iOwner, player.getCivilizationName(), pRemoveCity.getName()))

    def onGoldenAge(self, argsList):
    ## Platy Builder ##
        if CyGame().GetWorldBuilderMode() and not CvPlatyBuilderScreen.bPython: return
    ## Platy Builder ##
        'Golden Age'
        iPlayer = argsList[0]
        player = PyPlayer(iPlayer)
        if (not self.__LOG_GOLDENAGE):
            return
        CvUtil.pyPrint('Player %d Civilization %s has begun a golden age'
            %(iPlayer, player.getCivilizationName()))

    def onEndGoldenAge(self, argsList):
    ## Platy Builder ##
        if CyGame().GetWorldBuilderMode() and not CvPlatyBuilderScreen.bPython: return
    ## Platy Builder ##
        'End Golden Age'
        iPlayer = argsList[0]
        player = PyPlayer(iPlayer)
        if (not self.__LOG_ENDGOLDENAGE):
            return
        CvUtil.pyPrint('Player %d Civilization %s golden age has ended'
            %(iPlayer, player.getCivilizationName()))

    def onChangeWar(self, argsList):
    ## Platy Builder ##
        if CyGame().GetWorldBuilderMode() and not CvPlatyBuilderScreen.bPython: return
    ## Platy Builder ##
        'War Status Changes'
        bIsWar = argsList[0]
        iTeam = argsList[1]
        iRivalTeam = argsList[2]
        if (not self.__LOG_WARPEACE):
            return
        if (bIsWar):
            strStatus = "declared war"
        else:
            strStatus = "declared peace"
        CvUtil.pyPrint('Team %d has %s on Team %d'
            %(iTeam, strStatus, iRivalTeam))

    def onChat(self, argsList):
        'Chat Message Event'
        chatMessage = "%s" %(argsList[0],)

    def onSetPlayerAlive(self, argsList):
        'Set Player Alive Event'
        iPlayerID = argsList[0]
        bNewValue = argsList[1]
        CvUtil.pyPrint("Player %d's alive status set to: %d" %(iPlayerID, int(bNewValue)))

    def onPlayerChangeStateReligion(self, argsList):
    ## Platy Builder ##
        if CyGame().GetWorldBuilderMode() and not CvPlatyBuilderScreen.bPython: return
    ## Platy Builder ##
        'Player changes his state religion'
        iPlayer, iNewReligion, iOldReligion = argsList

    def onPlayerGoldTrade(self, argsList):
        'Player Trades gold to another player'
        iFromPlayer, iToPlayer, iGoldAmount = argsList

    def onCityBuilt(self, argsList):
        'City Built'
        city = argsList[0]
        if (city.getOwner() == gc.getGame().getActivePlayer()):
## AI AutoPlay ##
            if CyGame().getAIAutoPlay() == 0 and not CyGame().GetWorldBuilderMode():
                self.__eventEditCityNameBegin(city, False)
## AI AutoPlay ##
        CvUtil.pyPrint('City Built Event: %s' %(city.getName()))

    def onCityRazed(self, argsList):
        'City Razed'
        city, iPlayer = argsList
        iOwner = city.findHighestCulture()

        # Partisans!
        if city.getPopulation > 1 and iOwner != -1 and iPlayer != -1:
            owner = gc.getPlayer(iOwner)
            if not owner.isBarbarian() and owner.getNumCities() > 0:
                if gc.getTeam(owner.getTeam()).isAtWar(gc.getPlayer(iPlayer).getTeam()):
                    if gc.getNumEventTriggerInfos() > 0: # prevents mods that don't have events from getting an error
                        iEvent = CvUtil.findInfoTypeNum(gc.getEventTriggerInfo, gc.getNumEventTriggerInfos(),'EVENTTRIGGER_PARTISANS')
                        if iEvent != -1 and gc.getGame().isEventActive(iEvent) and owner.getEventTriggerWeight(iEvent) < 0:
                            triggerData = owner.initTriggeredData(iEvent, true, -1, city.getX(), city.getY(), iPlayer, city.getID(), -1, -1, -1, -1)

        CvUtil.pyPrint("City Razed Event: %s" %(city.getName(),))

    def onCityAcquired(self, argsList):
    ## Platy Builder ##
        if CyGame().GetWorldBuilderMode() and not CvPlatyBuilderScreen.bPython: return
    ## Platy Builder ##
        'City Acquired'
        iPreviousOwner,iNewOwner,pCity,bConquest,bTrade = argsList
        CvUtil.pyPrint('City Acquired Event: %s' %(pCity.getName()))

    def onCityAcquiredAndKept(self, argsList):
        'City Acquired and Kept'
        iOwner,pCity = argsList
        CvUtil.pyPrint('City Acquired and Kept Event: %s' %(pCity.getName()))

    def onCityLost(self, argsList):
        'City Lost'
        city = argsList[0]
        player = PyPlayer(city.getOwner())
        if (not self.__LOG_CITYLOST):
            return
        CvUtil.pyPrint('City %s was lost by Player %d Civilization %s'
            %(city.getName(), player.getID(), player.getCivilizationName()))

    def onCultureExpansion(self, argsList):
    ## Platy Builder ##
        if CyGame().GetWorldBuilderMode() and not CvPlatyBuilderScreen.bPython: return
    ## Platy Builder ##
        'City Culture Expansion'
        pCity = argsList[0]
        iPlayer = argsList[1]
        CvUtil.pyPrint("City %s's culture has expanded" %(pCity.getName(),))

    def onCityGrowth(self, argsList):
        'City Population Growth'
        pCity = argsList[0]
        iPlayer = argsList[1]
        CvUtil.pyPrint("%s has grown" %(pCity.getName(),))

    def onCityDoTurn(self, argsList):
        'City Production'
        pCity = argsList[0]
        iPlayer = argsList[1]
        CvAdvisorUtils.cityAdvise(pCity, iPlayer)

    def onCityBuildingUnit(self, argsList):
        'City begins building a unit'
        pCity = argsList[0]
        iUnitType = argsList[1]
        if (not self.__LOG_CITYBUILDING):
            return
        CvUtil.pyPrint("%s has begun building a %s" %(pCity.getName(),gc.getUnitInfo(iUnitType).getDescription()))

    def onCityBuildingBuilding(self, argsList):
        'City begins building a Building'
        pCity = argsList[0]
        iBuildingType = argsList[1]
        if (not self.__LOG_CITYBUILDING):
            return
        CvUtil.pyPrint("%s has begun building a %s" %(pCity.getName(),gc.getBuildingInfo(iBuildingType).getDescription()))

    def onCityRename(self, argsList):
        'City is renamed'
        pCity = argsList[0]
        if (pCity.getOwner() == gc.getGame().getActivePlayer()):
            self.__eventEditCityNameBegin(pCity, True)

    def onCityHurry(self, argsList):
        'City is renamed'
        pCity = argsList[0]
        iHurryType = argsList[1]

    def onVictory(self, argsList):
        'Victory'
        iTeam, iVictory = argsList
        if (iVictory >= 0 and iVictory < gc.getNumVictoryInfos()):
            victoryInfo = gc.getVictoryInfo(int(iVictory))
            CvUtil.pyPrint("Victory!  Team %d achieves a %s victory"
                %(iTeam, victoryInfo.getDescription()))

    def onVassalState(self, argsList):
        'Vassal State'
        iMaster, iVassal, bVassal = argsList

        if (bVassal):
            CvUtil.pyPrint("Team %d becomes a Vassal State of Team %d"
                %(iVassal, iMaster))
        else:
            CvUtil.pyPrint("Team %d revolts and is no longer a Vassal State of Team %d"
                %(iVassal, iMaster))

    def onGameUpdate(self, argsList):
        'sample generic event, called on each game turn slice'
        genericArgs = argsList[0][0]    # tuple of tuple of my args
        turnSlice = genericArgs[0]
        if "mauernB" in self.pb80:
            if self.pb80["mauernB"] == turnSlice:
                self.pb80_second_part()

    def onMouseEvent(self, argsList):
        'mouse handler - returns 1 if the event was consumed'
        eventType,mx,my,px,py,interfaceConsumed,screens = argsList
        if ( px!=-1 and py!=-1 ):
            if ( eventType == self.EventLButtonDown ):
                if (self.bAllowCheats and self.bCtrl and self.bAlt and CyMap().plot(px,py).isCity() and not interfaceConsumed):
                    # Launch Edit City Event
                    self.beginEvent( CvUtil.EventEditCity, (px,py) )
                    return 1

                elif (self.bAllowCheats and self.bCtrl and self.bShift and not interfaceConsumed):
                    # Launch Place Object Event
                    self.beginEvent( CvUtil.EventPlaceObject, (px, py) )
                    return 1

        if ( eventType == self.EventBack ):
            return CvScreensInterface.handleBack(screens)
        elif ( eventType == self.EventForward ):
            return CvScreensInterface.handleForward(screens)

        return 0


#################### TRIGGERED EVENTS ##################

    def __eventPlaceObjectBegin(self, argsList):
        'Place Object Event'
        CvDebugTools.CvDebugTools().initUnitPicker(argsList)

    def __eventPlaceObjectApply(self, playerID, userData, popupReturn):
        'Place Object Event Apply'
        if (getChtLvl() > 0):
            CvDebugTools.CvDebugTools().applyUnitPicker( (popupReturn, userData) )

    def __eventAwardTechsAndGoldBegin(self, argsList):
        'Award Techs & Gold Event'
        CvDebugTools.CvDebugTools().cheatTechs()

    def __eventAwardTechsAndGoldApply(self, playerID, netUserData, popupReturn):
        'Award Techs & Gold Event Apply'
        if (getChtLvl() > 0):
            CvDebugTools.CvDebugTools().applyTechCheat( (popupReturn) )

    def __eventShowWonderBegin(self, argsList):
        'Show Wonder Event'
        CvDebugTools.CvDebugTools().wonderMovie()

    def __eventShowWonderApply(self, playerID, netUserData, popupReturn):
        'Wonder Movie Apply'
        if (getChtLvl() > 0):
            CvDebugTools.CvDebugTools().applyWonderMovie( (popupReturn) )

## Platy Builder ##

    def __eventEditUnitNameBegin(self, argsList):
        pUnit = argsList
        popup = PyPopup.PyPopup(CvUtil.EventEditUnitName, EventContextTypes.EVENTCONTEXT_ALL)
        popup.setUserData((pUnit.getID(), CyGame().getActivePlayer()))
        popup.setBodyString(localText.getText("TXT_KEY_RENAME_UNIT", ()))
        popup.createEditBox(pUnit.getNameNoDesc())
        popup.setEditBoxMaxCharCount(25)
        popup.launch()

    def __eventEditUnitNameApply(self, playerID, userData, popupReturn):
        unit = gc.getPlayer(userData[1]).getUnit(userData[0])
        newName = popupReturn.getEditBoxString(0)
        unit.setName(newName)
        if CyGame().GetWorldBuilderMode():
            WBUnitScreen.WBUnitScreen(CvPlatyBuilderScreen.CvWorldBuilderScreen()).placeStats()
            WBUnitScreen.WBUnitScreen(CvPlatyBuilderScreen.CvWorldBuilderScreen()).placeCurrentUnit()

    def __eventEditCityNameBegin(self, city, bRename):
        popup = PyPopup.PyPopup(CvUtil.EventEditCityName, EventContextTypes.EVENTCONTEXT_ALL)
        popup.setUserData((city.getID(), bRename, CyGame().getActivePlayer()))
        popup.setHeaderString(localText.getText("TXT_KEY_NAME_CITY", ()))
        popup.setBodyString(localText.getText("TXT_KEY_SETTLE_NEW_CITY_NAME", ()))
        popup.createEditBox(city.getName())
        popup.setEditBoxMaxCharCount(15)
        popup.launch()

    def __eventEditCityNameApply(self, playerID, userData, popupReturn):
        city = gc.getPlayer(userData[2]).getCity(userData[0])
        cityName = popupReturn.getEditBoxString(0)
        city.setName(cityName, not userData[1])
        if CyGame().GetWorldBuilderMode() and not CyGame().isInAdvancedStart():
            WBCityEditScreen.WBCityEditScreen().placeStats()

    def __eventWBPlayerScriptPopupApply(self, playerID, userData, popupReturn):
        sScript = popupReturn.getEditBoxString(0)
        gc.getPlayer(userData[0]).setScriptData(CvUtil.convertToStr(sScript))
        WBPlayerScreen.WBPlayerScreen().placeScript()
        return

    def __eventWBCityScriptPopupApply(self, playerID, userData, popupReturn):
        sScript = popupReturn.getEditBoxString(0)
        pCity = gc.getPlayer(userData[0]).getCity(userData[1])
        pCity.setScriptData(CvUtil.convertToStr(sScript))
        WBCityEditScreen.WBCityEditScreen().placeScript()
        return

    def __eventWBUnitScriptPopupApply(self, playerID, userData, popupReturn):
        sScript = popupReturn.getEditBoxString(0)
        pUnit = gc.getPlayer(userData[0]).getUnit(userData[1])
        pUnit.setScriptData(CvUtil.convertToStr(sScript))
        WBUnitScreen.WBUnitScreen(CvPlatyBuilderScreen.CvWorldBuilderScreen()).placeScript()
        return

    def __eventWBScriptPopupBegin(self):
        return

    def __eventWBGameScriptPopupApply(self, playerID, userData, popupReturn):
        sScript = popupReturn.getEditBoxString(0)
        CyGame().setScriptData(CvUtil.convertToStr(sScript))
        WBGameDataScreen.WBGameDataScreen(CvPlatyBuilderScreen.CvWorldBuilderScreen()).placeScript()
        return

    def __eventWBPlotScriptPopupApply(self, playerID, userData, popupReturn):
        sScript = popupReturn.getEditBoxString(0)
        pPlot = CyMap().plot(userData[0], userData[1])
        pPlot.setScriptData(CvUtil.convertToStr(sScript))
        WBPlotScreen.WBPlotScreen().placeScript()
        return

    def __eventWBLandmarkPopupApply(self, playerID, userData, popupReturn):
        sScript = popupReturn.getEditBoxString(0)
        pPlot = CyMap().plot(userData[0], userData[1])
        iPlayer = userData[2]
        if userData[3] > -1:
            pSign = CyEngine().getSignByIndex(userData[3])
            iPlayer = pSign.getPlayerType()
            CyEngine().removeSign(pPlot, iPlayer)
        if len(sScript):
            if iPlayer == gc.getBARBARIAN_PLAYER():
                CyEngine().addLandmark(pPlot, CvUtil.convertToStr(sScript))
            else:
                CyEngine().addSign(pPlot, iPlayer, CvUtil.convertToStr(sScript))
        WBPlotScreen.iCounter = 10
        return
## Platy Builder ##
